//Ob Anog -"Write a kids book with the internet as your illustrator!"
//By Andy Quitmeyer
//Image search and parsing tools adapted from Andrew Robert's project "Kanjilizer"
//*note i change the name to the random, Ob Anog, because the previous title "StoryPeek" was just incredibly lame.
//Description:
//You are given a blank page from Highlights for Kids! magazine to fill with a educational story where the meaning of nouns is reinforced by a picture. You could whip out your pencil and start drawing  with your hand, but that seems more like a task for Australopithecus. Plus your buddy, the internet, just stopped by and wants to help. Now your friend isn’t the most creative guy, so you are going to have to write the story for him, but he will take over all the illustrating for you. 
//Also for some reason he hates dogs; well actually he is fine with more than one dog, but if you try to write a story involving a single “dog” the internet is going to mess up your story just to spite you (see technical note below). I think he  must have had a bad experience with a dog once (or maybe it’s because we all know that the internet is just way more into cats).
// One more thing to keep in mind, is that your friend has an incredibly dirty mind. Given the chance, he will probably provide a different illustration than you may have had in mind when you were writing your Barnyard story, “The Big Cock.” In general, the dictionary that he has to base most of his noun-ular identifications off of takes care of most suggestive materials, but the internet is probably the biggest pervert in the world.
//
//Technical/Aesthetic
//The core of this program is a copy of the full dictionary extracted from the DS game Scribblenauts. In this game you can theoretically write in any noun, and that noun will appear as a game-usable object. When I heard about this game, I immediately just started thinking about the power of having just a pure database of English nouns. From here, I initially wrote a program that takes in the text you write, formats it like a simple word processor, places it on a blank children’s page, and attempts to recognize and highlight just the nouns. Then I wanted the program to be able to fetch an image based on each noun discovered. Originally I was just going to have each word from the Scribblenauts dictionary link directly to the already-contextualized sprites in the game, but the roms for scribblenauts proved to be way too hard to hack.   
//After this, I decided to use Google image search as the new source for images. I ran into a gamut of problems trying to figure out the parser, and I got help from Andrew Roberts, who, I thought at the time, had a program quite similar to what I wanted to do. His program took in a Japanese character (hence the kanji class in my program), and searched for images in a variety of ways. In retrospect I should have just laid down all the basic parsing stuff from scratch but we hadn’t really learned it yet and seemed more daunting at the time. Instead I had to spend way more time adapting this program to select only a single target picture from all the pictures and logos on the search page, and for it to correctly display only the target image under the location of the corresponding word.
//Since the Scribblenauts dictionary only handles singular nouns, I needed to fake the handling of plurals. Luckily, in English most of our plurals just end with an “s” so I added an algorithm to check for a final “s” on a word but also make sure that the word is not just a singular noun that happens to end with an s, like gas, or grass, or floss.
//I based the blank page off a highlights magazine page right down to the font. The background gets filled in based on the content of the title of the story, and a subtle shadow is placed over this loaded content to keep the main blank page separate and above.
//Also, seriously, for some reason all the nouns work except for the word “dog”. The word “dogs” works fine, as does other words beginning with “d” or “do”, but just not the input of “dog”. It will screw up the order of the images as you type.
//
//Theoretical
//Using the scribblenauts dictionary gives this program a unique feel since it not only includes most common English nouns, it also includes many internet and sci-fi memes (like lolcats and time-machines).  Furthermore, even though I set out just to grab the pre-made pictures from Scribblenauts so that you would just write and your words could pop up as pictures, by using google image search as my source, I think I ended up with a much more interesting product. Instead of just illustrating your story, the program also graphically displays the dissonance and harmony between your and the internet’s concept of certain nouns.
//I think a program like this could also be used as an educational tool since it not only promotes basic typing skills, but reinforces the spelling and provides a visual feedback/reward for new vocabulary. Really young kids can also just toy around with letter combinations to experiment with random word formation.
//
//Further Development
//-----------------------------------------
//If anyone ever wants to take this little project further, here are some things that would be cool to add and enhance the program:
//
//Real handling of English plurals – like octopi, and wolves
//
//Handling of complex nouns- like nouns that use integrally use an adjective without hyphen like reading in “time machine” instead of “time” and “machine”
//
//Be able to erase and re-write pictures
//

















import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;
import javax.swing.*;
import java.util.*;
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.*;

public class StoryPeek extends PApplet {


PImage paper;
PImage shadow;
PFont myfont;

int leftmargin = 38;
int rightmargin = 20;
int topmargin = 128;
int bottommargin = height-20;
int titlemargin=180;
String buff = " ";
String[] tempWord= new String[1];
boolean didntTypeYet = true;
String[] words = new String[100];
int wordLineLength=1;


int cycleCount;
int textWordLength, textWordLengthPrime;
int lineCount=0;
String titleInput = new String();
String[] titleWords;
String currentInput = new String();
boolean entered = false;
int tempMatch;
String[] allNouns;
String joinedNouns; 

int indexNouns = 0;
String lowWordsTemp = " ";

int[] alreadyHas; 

//searchy and parsey things
//http://images.google.com/images?q=frog

  
  Kanji kanji;
  Kanji[] wordpics;
  TextField t = new TextField("enter japanese characters here", 20);
//  TextFieldListener l;
  String KanjiToLookUp;
  char k;
  int i;
  int enterCounter;
  String definitionsLabel;
  PFont courier;
  ImageSearcher imagesearcher;
  ImageSearcher wimagesearcher;
  ArrayList wordpicsearcher;
  ArrayList wordpicdrawer;
  //ImageDrawer imgdrawerLeft;
  ImageDrawer imgdrawerRight;

         StoryPeek theApplet=this;

SendToPic sendtopic;
String[] matchedNouns;
PImage[] holdPic;

void setup(){
  size(500,630);
  background(255);
  paper=loadImage("Pages.png");
  shadow= loadImage("Shadow.png");
  myfont=loadFont("CooperBlack-48.vlw");
  textFont(myfont);
wordpicsearcher= new ArrayList();
wordpicdrawer= new ArrayList();

  allNouns = loadStrings("nouns.txt");

  joinedNouns = join(allNouns, " ");
  joinedNouns=  joinedNouns.toLowerCase();
//make everything lowercase
  for(int u=0; u<allNouns.length; u++)
  {
    allNouns[u]= allNouns[u].toLowerCase();
  }
  
  
  //image searchy things
    definitionsLabel = "blah";
//  courier = loadFont("Courier-16.vlw");
//  frameRate(1);                          // don't display collage too fast
//  smooth();
//  bg = loadImage("background.gif");
//  topbar = loadImage("topbar.png");
//  bottombar = loadImage("bottombar.png");
//  imgdrawerLeft = new ImageDrawer(this,width,height, 0);
  imgdrawerRight = new ImageDrawer(this,width,height, width / 2);

alreadyHas=new int[100];
matchedNouns= new String[100];
for(int ttt=0; ttt<99; ttt++)
{alreadyHas[ttt]=0;
matchedNouns[ttt]=new String();
}

holdPic= new PImage[100];
}



void draw(){
  background(255);
  fill(0);

  //Create Title

  if(entered==false){

    //LOAD ALL THE FREAKIN NOUNS
    if (indexNouns < allNouns.length) {
      String[] NounPieces = split(allNouns[indexNouns], '\n');
      if (NounPieces.length == 2) {
        int x = int(NounPieces[0]) * 2;
        int y = int(NounPieces[1]) * 2;
        point(x, y);
      }
      // Go to the next line for the next run through draw()
      indexNouns = indexNouns + 1;

    }

    //Input Title     

    textAlign(CENTER);
    textSize(14);
    text("Type in the title of your fun story!", width/2, height*.94);
    text(titleInput, 18,height*.05);
    fill(100,20);
    //  rect(width/2-textWidth(currentInput)-3,height*98/100-14,textWidth(currentInput)+6,15);
    rectMode(CENTER);
    rect(width/2,height*98/100-5,textWidth(currentInput)+3,15);
    fill(0);
    text(currentInput, width/2, height*.98);
    // println(textWidth(currentInput));
    titleWords= splitTokens(titleInput);

  }

  //Enter into the world~~~~~~~~~~~~~~~~~~~

  if(key == ENTER || titleInput.length()!=0){

    //////////////Searchy test

    try
    {

   
    if (imgdrawerRight != null)
    {
      for (int i=0; i<imgdrawerRight.getImages().size(); i++)
      {
       // ImageObject imgobj = imgdrawerRight.getImageObj(i);
       
        holdPic[i]=imgdrawerRight.getImageObj(i).getPImage();
                holdPic[i]=imgdrawerRight.getImageObj(i).getPImage();
       //  image(imgobj.getPImage(),0,0, height, height);
         image(holdPic[0],0,0,height,height);
      }
    }
    }
    catch (IndexOutOfBoundsException e)
    {
      return;
    }

        
            
            /////////////Searchy test
    
    textAlign(LEFT);
    image(paper,0,0); 
    image(shadow,0,0);
    textSize(24);
    text(titleInput,42,85);
    

    //check text is loaded  text(allNouns[19155], width/2,height/2);
    //println(textWidth(titleInput));
    //println(titleWords[1]+" "+titleWords[2]+" "+titleWords[3]);
    textSize(16);

//    if((millis() % 500) < 250){  // Only fill cursor half the time
//      noFill();
//    }
//    else {
//      fill(255);
//      stroke(0);
//    }
    float rPos;
    // Store the cursor rectangle's position
    rPos = textWidth(buff) + leftmargin;
  //  rect(rPos+1, 19, 10, 21);

    // Some instructions at first
    if(didntTypeYet) {
      fill(0);
      //text("Use the keyboard.", 22, 40);
    }

    fill(0);
    //pushMatrix();
   //I  translate(rPos,10+25);
    char k;
    for(int i = 0;i < buff.length(); i++) {
      k = buff.charAt(i);
    //  translate(-textWidth(k),0);

      //scale(1.1);
    //  text(k,0,0);
      words = splitTokens(buff);
//words = buff.split("\w");
    }
   // popMatrix();


    //WRITE THE body TEXT

    textWordLength=0;
    lineCount=0;
    int picnum=1;
    for(int z=0; z< words.length; z=z+1)
    {
      //
      //for(int al=0; al<words.length; al=al+1)
      //
      //
      cycleCount++;
      // println(textWordLength);



      pushMatrix();
      if(textWordLength+int(textWidth(words[z]))>380 ){
        textWordLength=0;
        lineCount=lineCount+1;
      }
      translate(textWordLength,lineCount*80);

//Test matches

//      String[][] m1 = matchAll(joinedNouns, words[z].toLowerCase());
//      if(m1!=null)
//      {
//        fill(255,0,0);
//        println("matched word    "+words[z]+"    at index location "+z);
//      }
//      else
//      {
//        fill(0);
//      }

tempMatch=0;
//lowWordsTemp=words[z].toLowerCase;
//Search words for noun-ular matches
tempWord= splitTokens(words[z]," , . ? !");
if(tempWord.length!=0){
tempWord[0]=tempWord[0].toLowerCase();
//catch most of the plurals- 
//in english we got like 80 percent of our plurals ending in s, 
//but i also need to keep words that end with s but are not plural like "floss" and "glass" "gas"
if (tempWord[0].length()>2 
&& tempWord[0].charAt(tempWord[0].length()-1)=='s' 
&& tempWord[0].charAt(tempWord[0].length()-2)!='s'
&& tempWord[0].charAt(tempWord[0].length()-2)!='a')
{ 
  tempWord[0] = tempWord[0].substring(0, tempWord[0].length() - 1);
}


          for(int u=0; u<allNouns.length; u++)
          {
            if(tempWord[0].equals(allNouns[u])==true
//if(words[z].toLowerCase().equals(allNouns[u])==true 
           // || words[z].toLowerCase().equals(allNouns[u]+'.')==true 
           // || words[z].toLowerCase().equals(allNouns[u]+'s')==true 
           //|| words[z].toLowerCase().equals(allNouns[u]+'?')==true 
         //   || words[z].toLowerCase().equals(allNouns[u]+',')==true
            ){
        tempMatch=tempMatch+1;
          }
          }
}
    //if it is a noun then....      
          if(tempMatch!=0){   //tempMatch not being zero means that the current word we are on at location z is a noun
                fill(255,0,0);
                println("matched word    "+words[z]+"    at index location "+z);
          //   sendtopic.send(words[z], theApplet);

        //if(wordpicsearcher.isEmpty()){
         //wordpicsearcher.add(z,new Kanji(theApplet, words[z]));
         //    wordpicdrawer.add(z,new ImageDrawer(theApplet, width / 2, height, 0));
         //only search google for each word one time.
         if(alreadyHas[z]!=1 && keyPressed==true && key==' ' ){
              alreadyHas[z]=1;
                  wimagesearcher.parseURL(words[z]);
         }
         //}
         // kanji = new Kanji(theApplet, titleInput);

    //    wimagesearcher= new ImageSearcher(theApplet, words[z], "right");
//if(holdPic[imgdrawerRight.getImages().size()-1]!=null){
//image(holdPic[imgdrawerRight.getImages().size()-1], 40, 130, 60,50);
//}

if(holdPic[picnum]!=null){
image(holdPic[picnum], 40, 132, 60,50);
}
matchedNouns[z]=words[z];
picnum=picnum+1;
          }
        
            
         else
             {
              fill(0);
              alreadyHas[z]=0;
            }
            
  //  println(alreadyHas[z]);
  //Print the text
      text(words[z],leftmargin,122);


      

//    for (int uv=0; uv<imgdrawerRight.getImages().size(); uv++)
//      {
//if(holdPic[uv]!=null){
//image(holdPic[uv], width/2+uv*10, height/2+uv*10, 90,70);
//}
//      }

      textWordLength=textWordLength+ int(textWidth(words[z]))+10;
      popMatrix();

    }
  }
}



void keyPressed()
{
  if(entered==false){
    if(key == ENTER)
    {
      titleInput = currentInput;// = currentInput + key;
      currentInput = "";
                    //  kanji = new Kanji(theApplet, titleInput);
                        titleWords= splitTokens(titleInput);
                    wimagesearcher= new ImageSearcher(theApplet, join(titleWords, " "), "right");
      entered=true;

    }
    else if(key == BACKSPACE && currentInput.length() > 0)
    {
      currentInput = currentInput.substring(0, currentInput.length() - 1);
    }
    else if(textWidth(currentInput) > titlemargin)
    {
      currentInput = currentInput.substring(0, currentInput.length() - 1);
    }
    else
    {
      if(key!=SHIFT|| key!=65535){
        char ke;
        ke= (char)key;
     
      switch(ke){
   // case 8:
     // if(buff.length()>0){
    //    buff = buff.substring(0, buff.length()-1);
     // }
//      break;
    case 13:  // Avoid special keys
    case 10:
      lineCount=lineCount+1;
    case 65535:
    case SHIFT:
    case 127:
    case 27:
      break;
    default:
      //if(textWidth(buff+k)+leftmargin < width-rightmargin){
 currentInput = currentInput + ke;
      //}
      break;
    }
      
    }}
  }
  if(entered==true){

    char k;
    k = (char)key;
  
    switch(k){
    case 8:
      if(buff.length()>0){
        buff = buff.substring(0, buff.length()-1);
      }
      break;
    case 13:  // Avoid special keys
    case 10:
      lineCount=lineCount+1;
    case 65535:
    case SHIFT:
    case 127:
    case 27:
      break;
    default:
      //if(textWidth(buff+k)+leftmargin < width-rightmargin){
        if(textWordLength>370 && lineCount==5)
      
    {break;
    }
    else{
        didntTypeYet = false;
    
      //buff = buff.substring(0, currentInput.length() - 1);
    
      buff=buff+k;
      println("buffer length"+lineCount);  //220 MAX character ||2019 length 390 textword length
    
      break;
    }
    }
  }
}


public class SendToPic
{
  
  SendToPic()
  {

  }
  void send(String ss, StoryPeek theApple)
  {
       kanji = new Kanji(theApple, ss); 
  }
  
}
  

//  public class TextFieldListener implements ActionListener
//  {
//      StoryPeek theApplet;
//      
//      TextFieldListener(StoryPeek papp)
//      {
//        theApplet = papp;  
//      }
//    
//      public void actionPerformed(ActionEvent e)
//      {
//        kanji = new Kanji(theApplet, t.getText());
//        imgdrawerLeft = new ImageDrawer(theApplet, width / 2, height, 0);
//        imgdrawerRight = new ImageDrawer(theApplet, width / 2, height, width / 2);    
//        System.out.println("Made a new kanji, "+t.getText());
//      }
//
//  }


}

